/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.backend;

/**
 * This class removes deadcode generated by optimizations or code
 * transformation.
 */
public class DeadcodeElimination
    extends TreeWalker
{
    /**
     *
     */
    private QNode last;

    /**
     * Creates a new instruction handle.
     *
     * @param instruction
     * The instruction
     * @param prev
     * The handle of the next instruction in textual order.
     */
    public DeadcodeElimination(BasicBlock[] bblocks, BasicBlock[] eblocks)
    {
        super(bblocks, eblocks);
    }

    /**
     * Runs the deadcode algorithm.
     */
    public void run()
    {
        traverse();
    }
 
    protected void processNode(QNode node)
    {
    }

    protected void kill()
    {
        last = null;
    }
}
