/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.backend;

import at.dms.classfile.Instruction;
import at.dms.classfile.IincInstruction;

/**
 * ???
 */
class QIinc extends QNode
{
    /**
     */
    private IincInstruction iinc;

    /**
     */
    private QTemporary temp;

    public QIinc(Instruction insn, QTemporary temp)
    {
        this.iinc = (IincInstruction)insn;
        this.temp = temp;
    }

    /**
     * Human readable form.
     */
    public String toString()
    {
        return "iinc " + temp;
    }

    /**
     * The type of this instruction.
     */
    public int getType()
    {
        return at.dms.classfile.Constants.TYP_VOID;
    }

    /**
     * Duplicate this node: not implemented.
     */
    public QOrigin duplicate()
    {
        throw new RuntimeException("NYI");
    }

    /**
     * Returns the defined temporary.
     */
    public QTemporary getDef()
    {
        return temp;
    }

    /**
     * Returns the used temporaries.
     */
    public QTemporary[] getUses()
    {
        return new QTemporary[]{temp};
    }

    /**
     * Returns the parameters of this instruction.
     */
    public QOrigin[] getOrigins()
    {
        return new QOrigin[]{}; // !!! share
    }

    /**
     * Sets the parameters of this instruction: not implemented or not possible
     * on this type: throws RuntimeException.
     */
    public void setOrigin(QOrigin origin, int i)
    {
        throw new RuntimeException();
    }

    /**
     * Generates instructions for this quadruple.
     *
     * @param seq
     * The code sequence of instruction.
     */
    public void generate(CodeSequence seq)
    {
        seq.plantInstruction(new IincInstruction(temp.getRegister(),
                                                 iinc.getIncrement()));
    }
}
