/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.compiler;

import at.dms.util.MessageDescription;

public class CompilerMessages {
    public static final MessageDescription NO_VIABLE_ALT_FOR_CHAR =
        new MessageDescription("Unexpected char ''{0}''", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription UNEXPECTED_EOF =
        new MessageDescription("Unexpected end of file", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription ILLEGAL_CHAR =
        new MessageDescription("Unexpected char ''{0}''", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription SYNTAX_ERROR =
        new MessageDescription("Syntax error: {0}", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription UNKNOWN_FILE =
        new MessageDescription("File \"{0}\" not found", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription IO_EXCEPTION =
        new MessageDescription("IO Exception on \"{0}\": {1}", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription CANNOT_CREATE =
        new MessageDescription("Cannot create file \"{0}\"", null,
                               MessageDescription.LVL_ERROR);
    public static final MessageDescription COMPILATION_STARTED =
        new MessageDescription("[ start compilation in verbose mode ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription FILE_PARSED =
        new MessageDescription("[ parsed {0} in {1} ms ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription INTERFACES_CHECKED =
        new MessageDescription("[ checked interfaces in {0} ms ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription TYPES_TRANSFORMED =
        new MessageDescription("[ transformed types in {0} ms ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription BODY_CHECKED =
        new MessageDescription("[ checked body of {0} in {1} ms ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription CLASSFILE_GENERATED =
        new MessageDescription("[ optimized and generated {0} in {1} ms ]",
                               null, MessageDescription.LVL_INFO);
    public static final MessageDescription JAVA_CODE_GENERATED =
        new MessageDescription("[ generated {0} ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription CLASS_LOADED =
        new MessageDescription("[ loaded {0} ]", null,
                               MessageDescription.LVL_INFO);
    public static final MessageDescription COMPILATION_ENDED =
        new MessageDescription("[ compilation ended ]", null,
                               MessageDescription.LVL_INFO);
}
