/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * The original author of this file is DMS; refactorings, bug fixes and
 * extensions were done by Erwin Bolwidt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
package at.dms.kjc;

import at.dms.classfile.FieldInfo;

/**
 * This class represents loaded (compiled) class field.
 */
public class CBinaryField
    extends CField
{
    /**
     * Constructs a field export coming from a pre-compiled class file.
     *
     * @param owner
     * The owner of this field.
     *
     * @param fieldInfo
     * A field info from a class file.
     */
    public CBinaryField(CClass owner, FieldInfo fieldInfo)
    {
        super(owner,
              fieldInfo.getModifiers(),
              fieldInfo.getName().intern(),
              CType.parseSignature(fieldInfo.getSignature()),
              fieldInfo.isDeprecated());

        if (isFinal() && isStatic()) {
            Object value = fieldInfo.getConstantValue();
            if (value != null) {
                setValue(JLiteral.createLiteral(getType(), value));
            }
        }
    }
}
