/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 * Copyright (C) 2001    Erwin Bolwidt, Haarlem, The Netherlands.
 *
 * The original author of this file is DMS; refactorings, bug fixes and
 * extensions were done by Erwin Bolwidt.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package at.dms.kjc;

import at.dms.compiler.UnpositionedError;

/**
 * This class represents an interface context during check.
 */
public class CInterfaceContext
    extends CClassContext
{
    /**
     * Construct instance.
     *
     * @param parent
     * The parent context or null at top level.
     *
     * @param clazz
     * The corresponding class export.
     */
    public CInterfaceContext(CContext parent, CSourceClass clazz)
    {
        super(parent, clazz, null);
    }

    /**
     * Verify all final fields are initialized.
     *
     * @exception UnpositionedError
     * This error will be positioned soon.
     */
    public void close(JTypeDeclaration decl, CBodyContext virtual)
        throws UnpositionedError
    {
        /* XXX: !!!!!!
           JFieldDeclaration[] fields = decl.getFields();
           for (int i = 0; i < fields.length; i++) {
           check(virtual.getFieldInfo(fields[i].getField()).isInitialized(context),
           "uninitialized-final-field", fields[i].getField().getIdent());
           }
        */
    }

}

