// $ANTLR 2.7.1: "Ksm.g" -> "KsmParser.java"$

package at.dms.ksm;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

import java.util.ArrayList;
import java.util.List;

import at.dms.classfile.*;
import at.dms.compiler.NumberParser;

public class KsmParser extends antlr.LLkParser
       implements KsmTokenTypes
 {

    private static String convertFieldSignature(String name, int dims)
    {
        StringBuffer buffer = new StringBuffer();

        for (; dims > 0; dims -= 1) {
            buffer.append('[');
        }

        if (name.equals("boolean")) {
            buffer.append('Z');
        }
        else if (name.equals("byte")) {
            buffer.append('B');
        }
        else if (name.equals("char")) {
            buffer.append('C');
        }
        else if (name.equals("double")) {
            buffer.append('D');
        }
        else if (name.equals("float")) {
            buffer.append('F');
        }
        else if (name.equals("int")) {
            buffer.append('I');
        }
        else if (name.equals("long")) {
            buffer.append('J');
        }
        else if (name.equals("short")) {
            buffer.append('S');
        }
        else if (name.equals("void")) {
            buffer.append('V');
        }
        else {
            buffer.append('L');
            buffer.append(name.replace('.', '/'));
            buffer.append(';');
        }

        return buffer.toString();
    }

protected KsmParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public KsmParser(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected KsmParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public KsmParser(TokenStream lexer) {
  this(lexer,2);
}

public KsmParser(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final ClassInfo  aCompilationUnit(
		
	) throws RecognitionException, TokenStreamException {
		ClassInfo self;
		
		
		String    sourceFile = null;
		boolean   isInterface;
		short     access;
		String    thisClass;
		String    superClass = null;
		List      interfaces = new ArrayList();
		List      fields = new ArrayList();
		List      methods = new ArrayList();
		boolean   deprecated = false; //!!!
		
		
		{
		switch ( LA(1)) {
		case 6:
		{
			sourceFile=aSourceSpec();
			break;
		}
		case LITERAL_class:
		case LITERAL_interface:
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_private:
		case LITERAL_static:
		case LITERAL_abstract:
		case LITERAL_final:
		case LITERAL_native:
		case LITERAL_strictfp:
		case LITERAL_synchronized:
		case LITERAL_transient:
		case LITERAL_volatile:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		access=aAccess();
		isInterface=aTypeSpec();
		thisClass=aClassSignature(false);
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			superClass=aSuperSpec();
			break;
		}
		case LBRACE:
		case LITERAL_implements:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_implements:
		{
			aImplementsSpec(interfaces);
			break;
		}
		case LBRACE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LBRACE);
		{
		_loop6:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				aMemberSpec(fields, methods);
			}
			else {
				break _loop6;
			}
			
		} while (true);
		}
		match(RBRACE);
		
		if (isInterface) {
		access |= Constants.ACC_INTERFACE;
		}
		
		self = new ClassInfo(access,
		thisClass, superClass, interfaces,
		fields, methods, null, /*!!!inner classes*/
		sourceFile,
		deprecated);
		
		return self;
	}
	
	public final String  aSourceSpec(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		
		match(6);
		self=aStringLiteral();
		return self;
	}
	
	public final short  aAccess(
		
	) throws RecognitionException, TokenStreamException {
		short self = 0;
		
		
		{
		_loop11:
		do {
			switch ( LA(1)) {
			case LITERAL_public:
			{
				match(LITERAL_public);
				self |= Constants.ACC_PUBLIC;
				break;
			}
			case LITERAL_protected:
			{
				match(LITERAL_protected);
				self |= Constants.ACC_PROTECTED;
				break;
			}
			case LITERAL_private:
			{
				match(LITERAL_private);
				self |= Constants.ACC_PRIVATE;
				break;
			}
			case LITERAL_static:
			{
				match(LITERAL_static);
				self |= Constants.ACC_STATIC;
				break;
			}
			case LITERAL_abstract:
			{
				match(LITERAL_abstract);
				self |= Constants.ACC_ABSTRACT;
				break;
			}
			case LITERAL_final:
			{
				match(LITERAL_final);
				self |= Constants.ACC_FINAL;
				break;
			}
			case LITERAL_native:
			{
				match(LITERAL_native);
				self |= Constants.ACC_NATIVE;
				break;
			}
			case LITERAL_strictfp:
			{
				match(LITERAL_strictfp);
				self |= Constants.ACC_STRICT;
				break;
			}
			case LITERAL_synchronized:
			{
				match(LITERAL_synchronized);
				self |= Constants.ACC_SYNCHRONIZED;
				break;
			}
			case LITERAL_transient:
			{
				match(LITERAL_transient);
				self |= Constants.ACC_TRANSIENT;
				break;
			}
			case LITERAL_volatile:
			{
				match(LITERAL_volatile);
				self |= Constants.ACC_VOLATILE;
				break;
			}
			default:
			{
				break _loop11;
			}
			}
		} while (true);
		}
		return self;
	}
	
	public final boolean  aTypeSpec(
		
	) throws RecognitionException, TokenStreamException {
		boolean self;
		
		
		switch ( LA(1)) {
		case LITERAL_class:
		{
			match(LITERAL_class);
			self = false;
			break;
		}
		case LITERAL_interface:
		{
			match(LITERAL_interface);
			self = true;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final String  aClassSignature(
		boolean arrayAllowed
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		
		String name;
		int    dims = 0;
		
		
		name=aName();
		{
		_loop67:
		do {
			if ((LA(1)==LBRACK) && (LA(2)==RBRACK)) {
				match(LBRACK);
				match(RBRACK);
				dims += 1;
			}
			else {
				break _loop67;
			}
			
		} while (true);
		}
		
		if (dims == 0) {
		self = name.replace('.', '/');
		}
		else {
		if (! arrayAllowed) {
		throw new antlr.RecognitionException("arrays are not allowed here");
		}
		self = convertFieldSignature(name, dims);
		}
		
		return self;
	}
	
	public final String  aSuperSpec(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		
		match(LITERAL_extends);
		self=aClassSignature(false);
		return self;
	}
	
	public final void aImplementsSpec(
		List interfaces
	) throws RecognitionException, TokenStreamException {
		
		
		String self;
		
		
		match(LITERAL_implements);
		self=aClassSignature(false);
		interfaces.add(self);
		{
		_loop15:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				self=aClassSignature(false);
				interfaces.add(self);
			}
			else {
				break _loop15;
			}
			
		} while (true);
		}
	}
	
	public final void aMemberSpec(
		List fields, List methods
	) throws RecognitionException, TokenStreamException {
		
		
		short      access;
		String     type;
		String     name;
		FieldInfo  fld;
		MethodInfo mtd;
		
		
		access=aAccess();
		type=aFieldSignature();
		name=aName();
		{
		switch ( LA(1)) {
		case SEMI:
		case EQUAL:
		{
			fld=aFieldSpec(access, type, name);
			fields.add(fld);
			break;
		}
		case LPAREN:
		{
			mtd=aMethodSpec(access, type, name);
			methods.add(mtd);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
	}
	
	public final String  aStringLiteral(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		Token  token = null;
		
		token = LT(1);
		match(STRING_LITERAL);
		
		self = token.getText();
		self = Utils.convertString(self);
		
		return self;
	}
	
	public final String  aFieldSignature(
		
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		
		String name;
		int    dims = 0;
		
		
		name=aName();
		{
		_loop70:
		do {
			if ((LA(1)==LBRACK) && (LA(2)==RBRACK)) {
				match(LBRACK);
				match(RBRACK);
				dims += 1;
			}
			else {
				break _loop70;
			}
			
		} while (true);
		}
		self = convertFieldSignature(name, dims);
		return self;
	}
	
	public final String  aName(
		
	) throws RecognitionException, TokenStreamException {
		String self;
		
		
		String ident;
		
		
		ident=aIdentifier();
		self = ident;
		{
		_loop73:
		do {
			if ((LA(1)==DOT)) {
				match(DOT);
				ident=aIdentifier();
				self += "/" + ident;
			}
			else {
				break _loop73;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final FieldInfo  aFieldSpec(
		short access, String type, String name
	) throws RecognitionException, TokenStreamException {
		FieldInfo self;
		
		
		Object    value = null;
		boolean   deprecated = false; //!!!
		boolean   synthetic = false;  //!!!
		
		
		{
		switch ( LA(1)) {
		case EQUAL:
		{
			value=aFieldValue();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(SEMI);
		
		self = new FieldInfo(access, name, type, value, deprecated, synthetic);
		
		return self;
	}
	
	public final MethodInfo  aMethodSpec(
		short access, String type, String name
	) throws RecognitionException, TokenStreamException {
		MethodInfo self;
		
		
		String[]   exceptions;
		MethodBody methodBody = null;
		boolean    deprecated = false; //!!!
		boolean    synthetic = false;  //!!!
		
		
		type=aMethodSignature(type);
		exceptions=aThrowsSpec();
		{
		switch ( LA(1)) {
		case LBRACE:
		{
			methodBody=aMethodBody();
			break;
		}
		case SEMI:
		{
			match(SEMI);
			methodBody = null;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		CodeInfo      codeInfo;
		
		if (methodBody == null) {
		/* xxx: check is abstract */
		codeInfo = null;
		}
		else {
		/* xxx: check is not abstract */
		codeInfo = methodBody.genCodeInfo();
		}
		
		self = new MethodInfo(access, name, type,
		exceptions, codeInfo,
		deprecated, synthetic);
		
		return self;
	}
	
	public final Object  aFieldValue(
		
	) throws RecognitionException, TokenStreamException {
		Object self;
		
		
		match(EQUAL);
		self=aLiteral();
		return self;
	}
	
	public final Object  aLiteral(
		
	) throws RecognitionException, TokenStreamException {
		Object self = null;
		
		
		switch ( LA(1)) {
		case NUM_DOUBLE:
		{
			self=aDoubleLiteral();
			break;
		}
		case NUM_FLOAT:
		{
			self=aFloatLiteral();
			break;
		}
		case INT_LITERAL:
		{
			self=aIntegerLiteral();
			break;
		}
		case LONG_LITERAL:
		{
			self=aLongLiteral();
			break;
		}
		case STRING_LITERAL:
		{
			self=aStringLiteral();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final String  aMethodSignature(
		String returnType
	) throws RecognitionException, TokenStreamException {
		String self;
		
		
		StringBuffer buffer = new StringBuffer();
		String       type;
		
		
		match(LPAREN);
		buffer.append('(');
		{
		switch ( LA(1)) {
		case IDENT:
		case QUOTED_IDENT:
		case INIT:
		case CLINIT:
		{
			type=aFieldSignature();
			buffer.append(type);
			{
			_loop64:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					type=aFieldSignature();
					buffer.append(type);
				}
				else {
					break _loop64;
				}
				
			} while (true);
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(RPAREN);
		
		buffer.append(')');
		buffer.append(returnType);
		
		self = buffer.toString();
		
		return self;
	}
	
	public final String[]  aThrowsSpec(
		
	) throws RecognitionException, TokenStreamException {
		String[] self;
		
		
		List   list = new ArrayList();
		String item;
		
		
		{
		switch ( LA(1)) {
		case LITERAL_throws:
		{
			match(LITERAL_throws);
			item=aClassSignature(false);
			list.add(item);
			{
			_loop26:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					item=aClassSignature(false);
					list.add(item);
				}
				else {
					break _loop26;
				}
				
			} while (true);
			}
			break;
		}
		case LBRACE:
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		
		if (list.size() == 0) {
		self = null;
		}
		else {
		self = (String[])list.toArray(new String[list.size()]);
		}
		
		return self;
	}
	
	public final MethodBody  aMethodBody(
		
	) throws RecognitionException, TokenStreamException {
		MethodBody self;
		
		
		self = new MethodBody();
		
		
		match(LBRACE);
		{
		int _cnt29=0;
		_loop29:
		do {
			switch ( LA(1)) {
			case 26:
			case 30:
			case 31:
			{
				aDirective(self);
				break;
			}
			case IDENT:
			case QUOTED_IDENT:
			case INIT:
			case CLINIT:
			{
				aLabelDeclaration(self);
				break;
			}
			default:
				if (((LA(1) >= 32 && LA(1) <= 171))) {
					aInstruction(self);
				}
			else {
				if ( _cnt29>=1 ) { break _loop29; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			}
			_cnt29++;
		} while (true);
		}
		match(RBRACE);
		return self;
	}
	
	public final void aDirective(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		switch ( LA(1)) {
		case 26:
		{
			aVariableDirective(methodBody);
			break;
		}
		case 30:
		{
			aLineDirective(methodBody);
			break;
		}
		case 31:
		{
			aCatchDirective(methodBody);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
	}
	
	public final void aLabelDeclaration(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		String name;
		
		
		name=aIdentifier();
		match(COLON);
		methodBody.addLabel(name);
	}
	
	public final void aInstruction(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		Instruction instruction;
		
		
		{
		if ((LA(1)==32)) {
			match(32);
		}
		else if (((LA(1) >= 33 && LA(1) <= 171))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		switch ( LA(1)) {
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
		case 40:
		case 41:
		case 42:
		case 43:
		case 44:
		case 45:
		case 46:
		case 47:
		case 48:
		case 49:
		case 50:
		case 51:
		case 52:
		case 53:
		case 54:
		case 55:
		case 56:
		case 57:
		case 58:
		case 59:
		case 60:
		case 61:
		case 62:
		case 63:
		case 64:
		case 65:
		case 66:
		case 67:
		case 68:
		case 69:
		case 70:
		case 71:
		case 72:
		case 73:
		case 74:
		case 75:
		case 76:
		case 77:
		case 78:
		case 79:
		case 80:
		case 81:
		case 82:
		case 83:
		case 84:
		case 85:
		case 86:
		case 87:
		case 88:
		case 89:
		case 90:
		case 91:
		case 92:
		case 93:
		case 94:
		case 95:
		case 96:
		case 97:
		case 98:
		case 99:
		case 100:
		case 101:
		case 102:
		case 103:
		case 104:
		case 105:
		case 106:
		case 107:
		case 108:
		case 109:
		case 110:
		case 111:
		case 112:
		case 113:
		case 114:
		case 115:
		case 116:
		case 117:
		case 118:
		case 119:
		case 120:
		case 121:
		case 122:
		case 123:
		case 124:
		case 125:
		{
			instruction=aNoArgInstruction();
			break;
		}
		case 126:
		{
			instruction=aPushLiteralInstruction();
			break;
		}
		case 127:
		case 128:
		case 129:
		case 130:
		{
			instruction=aFieldRefInstruction();
			break;
		}
		case 131:
		case 132:
		case 133:
		{
			instruction=aMethodRefInstruction();
			break;
		}
		case 134:
		case 135:
		case 136:
		case 137:
		{
			instruction=aClassRefInstruction();
			break;
		}
		case 138:
		case 139:
		case 140:
		case 141:
		case 142:
		case 143:
		case 144:
		case 145:
		case 146:
		case 147:
		case 148:
		case 149:
		case 150:
		case 151:
		case 152:
		case 153:
		case 154:
		case 155:
		{
			instruction=aJumpInstruction();
			break;
		}
		case 156:
		case 157:
		case 158:
		case 159:
		case 160:
		case 161:
		case 162:
		case 163:
		case 164:
		case 165:
		case 166:
		{
			instruction=aLocalVarInstruction();
			break;
		}
		case 167:
		{
			instruction=aNewarrayInstruction();
			break;
		}
		case 168:
		{
			instruction=aMultiarrayInstruction();
			break;
		}
		case 169:
		{
			instruction=aInvokeinterfaceInstruction();
			break;
		}
		case 170:
		{
			instruction=aIincInstruction();
			break;
		}
		case 171:
		{
			instruction=aSwitchInstruction();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		methodBody.addInstruction(instruction);
	}
	
	public final void aVariableDirective(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		int    slot;
		String name;
		String type;
		LabelReference start = null;
		LabelReference end = null;
		
		
		match(26);
		slot=aInteger();
		match(COLON);
		name=aIdentifier();
		type=aFieldSignature();
		match(LBRACK);
		start=aLabelRef();
		match(COMMA);
		end=aLabelRef();
		match(RBRACK);
		
		if (slot < 0 || slot >= Short.MAX_VALUE) {
		throw new antlr.RecognitionException("Slot " + slot
			+ " outside of valid range");
		}
		
		methodBody.addVariable(name, type, start, end, (short)slot);
		
	}
	
	public final void aLineDirective(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		int value;
		
		
		match(30);
		value=aInteger();
		methodBody.addLineNumber(value);
	}
	
	public final void aCatchDirective(
		MethodBody methodBody
	) throws RecognitionException, TokenStreamException {
		
		
		String thrown = null;
		LabelReference handler;
		LabelReference start;
		LabelReference end;
		
		
		match(31);
		handler=aLabelRef();
		{
		switch ( LA(1)) {
		case IDENT:
		case QUOTED_IDENT:
		case INIT:
		case CLINIT:
		{
			thrown=aClassSignature(false);
			break;
		}
		case LBRACK:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		match(LBRACK);
		start=aLabelRef();
		match(COMMA);
		end=aLabelRef();
		match(RBRACK);
		methodBody.addHandler(thrown, start, end, handler);
	}
	
	public final int  aInteger(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		Integer lit;
		
		
		lit=aIntegerLiteral();
		self = lit.intValue();
		return self;
	}
	
	public final String  aIdentifier(
		
	) throws RecognitionException, TokenStreamException {
		String self = null;
		
		Token  id1 = null;
		Token  id2 = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			id1 = LT(1);
			match(IDENT);
			self = id1.getText();
			break;
		}
		case QUOTED_IDENT:
		{
			id2 = LT(1);
			match(QUOTED_IDENT);
			self = id2.getText().substring(0, id2.getText().length() - 1);
			break;
		}
		case INIT:
		{
			match(INIT);
			self = "<init>";
			break;
		}
		case CLINIT:
		{
			match(CLINIT);
			self = "<clinit>";
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final LabelReference  aLabelRef(
		
	) throws RecognitionException, TokenStreamException {
		LabelReference self = null;
		
		
		String name;
		
		
		name=aIdentifier();
		self = new LabelReference(name);
		return self;
	}
	
	public final Instruction  aNoArgInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int opcode;
		
		
		opcode=aNoArgOpcode();
		self = new NoArgInstruction(opcode);
		return self;
	}
	
	public final Instruction  aPushLiteralInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		Object lit;
		
		
		match(126);
		{
		switch ( LA(1)) {
		case NUM_DOUBLE:
		{
			lit=aDoubleLiteral();
			self = new PushLiteralInstruction(((Double)lit).doubleValue());
			break;
		}
		case NUM_FLOAT:
		{
			lit=aFloatLiteral();
			self = new PushLiteralInstruction(((Float)lit).floatValue());
			break;
		}
		case INT_LITERAL:
		{
			lit=aIntegerLiteral();
			self = new PushLiteralInstruction(((Integer)lit).intValue());
			break;
		}
		case LONG_LITERAL:
		{
			lit=aLongLiteral();
			self = new PushLiteralInstruction(((Long)lit).longValue());
			break;
		}
		case STRING_LITERAL:
		{
			lit=aStringLiteral();
			self = new PushLiteralInstruction((String)lit);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		return self;
	}
	
	public final Instruction  aFieldRefInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int    opcode;
		String name;
		String type;
		
		
		opcode=aFieldRefOpcode();
		type=aFieldSignature();
		name=aName();
		self = new FieldRefInstruction(opcode, name, type);
		return self;
	}
	
	public final Instruction  aMethodRefInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int    opcode;
		String name;
		String type;
		
		
		opcode=aMethodRefOpcode();
		type=aFieldSignature();
		name=aName();
		type=aMethodSignature(type);
		self = new MethodRefInstruction(opcode, name, type);
		return self;
	}
	
	public final Instruction  aClassRefInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int    opcode;
		String name;
		
		
		opcode=aClassRefOpcode();
		name=aClassSignature(true);
		self = new ClassRefInstruction(opcode, name);
		return self;
	}
	
	public final Instruction  aJumpInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int opcode;
		LabelReference target;
		
		
		opcode=aJumpOpcode();
		target=aLabelRef();
		self = new JumpInstruction(opcode, target);
		return self;
	}
	
	public final Instruction  aLocalVarInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int opcode;
		int var;
		
		
		opcode=aLocalVarOpcode();
		var=aInteger();
		self = new LocalVarInstruction(opcode, var);
		return self;
	}
	
	public final Instruction  aNewarrayInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		String name;
		byte   code;
		
		
		match(167);
		name=aIdentifier();
		
		if (name.equals("boolean")) {
		code = 4;
		}
		else if (name.equals("char")) {
		code = 5;
		}
		else if (name.equals("float")) {
		code = 6;
		}
		else if (name.equals("double")) {
		code = 7;
		}
		else if (name.equals("byte")) {
		code = 8;
		}
		else if (name.equals("short")) {
		code = 9;
		}
		else if (name.equals("int")) {
		code = 10;
		} 
		else if (name.equals("long")) {
		code = 11;
		}
		else {
		throw new antlr.RecognitionException("Bad type " + name
			     + " for newarray");
		}
		self = new NewarrayInstruction(code);
		
		return self;
	}
	
	public final Instruction  aMultiarrayInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		String type;
		int    dims;
		
		
		match(168);
		type=aClassSignature(true);
		dims=aInteger();
		self = new MultiarrayInstruction(type, dims);
		return self;
	}
	
	public final Instruction  aInvokeinterfaceInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		String name;
		String type;
		int    args;
		
		
		match(169);
		type=aFieldSignature();
		name=aName();
		type=aMethodSignature(type);
		args=aInteger();
		self = new InvokeinterfaceInstruction(name, type, args);
		return self;
	}
	
	public final Instruction  aIincInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		int var;
		int inc;
		
		
		match(170);
		var=aInteger();
		inc=aInteger();
		self = new IincInstruction(var, inc);
		return self;
	}
	
	public final Instruction  aSwitchInstruction(
		
	) throws RecognitionException, TokenStreamException {
		Instruction self;
		
		
		List matches = new ArrayList();
		List targets = new ArrayList();
		int  value;
		LabelReference target;
		
		
		match(171);
		{
		_loop59:
		do {
			if ((LA(1)==INT_LITERAL)) {
				value=aInteger();
				match(COLON);
				target=aLabelRef();
				
				matches.add(new Integer(value));
				targets.add(target);
				
			}
			else {
				break _loop59;
			}
			
		} while (true);
		}
		match(172);
		match(COLON);
		target=aLabelRef();
		
		self = new SwitchInstruction(target, matches, targets);
		
		return self;
	}
	
	public final int  aNoArgOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 33:
		{
			match(33);
			self = Constants.opc_aaload;
			break;
		}
		case 34:
		{
			match(34);
			self = Constants.opc_aastore;
			break;
		}
		case 35:
		{
			match(35);
			self = Constants.opc_aconst_null;
			break;
		}
		case 36:
		{
			match(36);
			self = Constants.opc_areturn;
			break;
		}
		case 37:
		{
			match(37);
			self = Constants.opc_arraylength;
			break;
		}
		case 38:
		{
			match(38);
			self = Constants.opc_athrow;
			break;
		}
		case 39:
		{
			match(39);
			self = Constants.opc_baload;
			break;
		}
		case 40:
		{
			match(40);
			self = Constants.opc_bastore;
			break;
		}
		case 41:
		{
			match(41);
			self = Constants.opc_caload;
			break;
		}
		case 42:
		{
			match(42);
			self = Constants.opc_castore;
			break;
		}
		case 43:
		{
			match(43);
			self = Constants.opc_d2f;
			break;
		}
		case 44:
		{
			match(44);
			self = Constants.opc_d2i;
			break;
		}
		case 45:
		{
			match(45);
			self = Constants.opc_d2l;
			break;
		}
		case 46:
		{
			match(46);
			self = Constants.opc_dadd;
			break;
		}
		case 47:
		{
			match(47);
			self = Constants.opc_daload;
			break;
		}
		case 48:
		{
			match(48);
			self = Constants.opc_dastore;
			break;
		}
		case 49:
		{
			match(49);
			self = Constants.opc_dcmpg;
			break;
		}
		case 50:
		{
			match(50);
			self = Constants.opc_dcmpl;
			break;
		}
		case 51:
		{
			match(51);
			self = Constants.opc_ddiv;
			break;
		}
		case 52:
		{
			match(52);
			self = Constants.opc_dmul;
			break;
		}
		case 53:
		{
			match(53);
			self = Constants.opc_dneg;
			break;
		}
		case 54:
		{
			match(54);
			self = Constants.opc_drem;
			break;
		}
		case 55:
		{
			match(55);
			self = Constants.opc_dreturn;
			break;
		}
		case 56:
		{
			match(56);
			self = Constants.opc_dsub;
			break;
		}
		case 57:
		{
			match(57);
			self = Constants.opc_dup;
			break;
		}
		case 58:
		{
			match(58);
			self = Constants.opc_dup_x1;
			break;
		}
		case 59:
		{
			match(59);
			self = Constants.opc_dup_x2;
			break;
		}
		case 60:
		{
			match(60);
			self = Constants.opc_dup2;
			break;
		}
		case 61:
		{
			match(61);
			self = Constants.opc_dup2_x1;
			break;
		}
		case 62:
		{
			match(62);
			self = Constants.opc_dup2_x2;
			break;
		}
		case 63:
		{
			match(63);
			self = Constants.opc_f2d;
			break;
		}
		case 64:
		{
			match(64);
			self = Constants.opc_f2i;
			break;
		}
		case 65:
		{
			match(65);
			self = Constants.opc_f2l;
			break;
		}
		case 66:
		{
			match(66);
			self = Constants.opc_fadd;
			break;
		}
		case 67:
		{
			match(67);
			self = Constants.opc_faload;
			break;
		}
		case 68:
		{
			match(68);
			self = Constants.opc_fastore;
			break;
		}
		case 69:
		{
			match(69);
			self = Constants.opc_fcmpg;
			break;
		}
		case 70:
		{
			match(70);
			self = Constants.opc_fcmpl;
			break;
		}
		case 71:
		{
			match(71);
			self = Constants.opc_fdiv;
			break;
		}
		case 72:
		{
			match(72);
			self = Constants.opc_fmul;
			break;
		}
		case 73:
		{
			match(73);
			self = Constants.opc_fneg;
			break;
		}
		case 74:
		{
			match(74);
			self = Constants.opc_frem;
			break;
		}
		case 75:
		{
			match(75);
			self = Constants.opc_freturn;
			break;
		}
		case 76:
		{
			match(76);
			self = Constants.opc_fsub;
			break;
		}
		case 77:
		{
			match(77);
			self = Constants.opc_i2b;
			break;
		}
		case 78:
		{
			match(78);
			self = Constants.opc_i2c;
			break;
		}
		case 79:
		{
			match(79);
			self = Constants.opc_i2d;
			break;
		}
		case 80:
		{
			match(80);
			self = Constants.opc_i2f;
			break;
		}
		case 81:
		{
			match(81);
			self = Constants.opc_i2l;
			break;
		}
		case 82:
		{
			match(82);
			self = Constants.opc_i2s;
			break;
		}
		case 83:
		{
			match(83);
			self = Constants.opc_iadd;
			break;
		}
		case 84:
		{
			match(84);
			self = Constants.opc_iaload;
			break;
		}
		case 85:
		{
			match(85);
			self = Constants.opc_iand;
			break;
		}
		case 86:
		{
			match(86);
			self = Constants.opc_iastore;
			break;
		}
		case 87:
		{
			match(87);
			self = Constants.opc_idiv;
			break;
		}
		case 88:
		{
			match(88);
			self = Constants.opc_imul;
			break;
		}
		case 89:
		{
			match(89);
			self = Constants.opc_ineg;
			break;
		}
		case 90:
		{
			match(90);
			self = Constants.opc_ior;
			break;
		}
		case 91:
		{
			match(91);
			self = Constants.opc_irem;
			break;
		}
		case 92:
		{
			match(92);
			self = Constants.opc_ireturn;
			break;
		}
		case 93:
		{
			match(93);
			self = Constants.opc_ishl;
			break;
		}
		case 94:
		{
			match(94);
			self = Constants.opc_ishr;
			break;
		}
		case 95:
		{
			match(95);
			self = Constants.opc_isub;
			break;
		}
		case 96:
		{
			match(96);
			self = Constants.opc_iushr;
			break;
		}
		case 97:
		{
			match(97);
			self = Constants.opc_ixor;
			break;
		}
		case 98:
		{
			match(98);
			self = Constants.opc_l2d;
			break;
		}
		case 99:
		{
			match(99);
			self = Constants.opc_l2f;
			break;
		}
		case 100:
		{
			match(100);
			self = Constants.opc_l2i;
			break;
		}
		case 101:
		{
			match(101);
			self = Constants.opc_ladd;
			break;
		}
		case 102:
		{
			match(102);
			self = Constants.opc_laload;
			break;
		}
		case 103:
		{
			match(103);
			self = Constants.opc_land;
			break;
		}
		case 104:
		{
			match(104);
			self = Constants.opc_lastore;
			break;
		}
		case 105:
		{
			match(105);
			self = Constants.opc_lcmp;
			break;
		}
		case 106:
		{
			match(106);
			self = Constants.opc_ldiv;
			break;
		}
		case 107:
		{
			match(107);
			self = Constants.opc_lmul;
			break;
		}
		case 108:
		{
			match(108);
			self = Constants.opc_lneg;
			break;
		}
		case 109:
		{
			match(109);
			self = Constants.opc_lor;
			break;
		}
		case 110:
		{
			match(110);
			self = Constants.opc_lrem;
			break;
		}
		case 111:
		{
			match(111);
			self = Constants.opc_lreturn;
			break;
		}
		case 112:
		{
			match(112);
			self = Constants.opc_lshl;
			break;
		}
		case 113:
		{
			match(113);
			self = Constants.opc_lshr;
			break;
		}
		case 114:
		{
			match(114);
			self = Constants.opc_lsub;
			break;
		}
		case 115:
		{
			match(115);
			self = Constants.opc_lushr;
			break;
		}
		case 116:
		{
			match(116);
			self = Constants.opc_lxor;
			break;
		}
		case 117:
		{
			match(117);
			self = Constants.opc_monitorenter;
			break;
		}
		case 118:
		{
			match(118);
			self = Constants.opc_monitorexit;
			break;
		}
		case 119:
		{
			match(119);
			self = Constants.opc_nop;
			break;
		}
		case 120:
		{
			match(120);
			self = Constants.opc_pop;
			break;
		}
		case 121:
		{
			match(121);
			self = Constants.opc_pop2;
			break;
		}
		case 122:
		{
			match(122);
			self = Constants.opc_return;
			break;
		}
		case 123:
		{
			match(123);
			self = Constants.opc_saload;
			break;
		}
		case 124:
		{
			match(124);
			self = Constants.opc_sastore;
			break;
		}
		case 125:
		{
			match(125);
			self = Constants.opc_swap;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final Double  aDoubleLiteral(
		
	) throws RecognitionException, TokenStreamException {
		Double self;
		
		Token  token = null;
		
		token = LT(1);
		match(NUM_DOUBLE);
		
		String text = token.getText();
		
		if (text.startsWith("<NaN>")) {
		self = new Double(Double.NaN);
		}
		else if (text.startsWith("<Inf>")) {
		self = new Double(Double.POSITIVE_INFINITY);
		}
		else if (text.startsWith("-<Inf>")) {
		self = new Double(Double.NEGATIVE_INFINITY);
		}
		else {
		try {
		self = new Double(text);
		}
		catch (NumberFormatException e) {
		throw new antlr.RecognitionException(e.toString());
		}
		}
		
		return self;
	}
	
	public final Float  aFloatLiteral(
		
	) throws RecognitionException, TokenStreamException {
		Float self;
		
		Token  token = null;
		
		token = LT(1);
		match(NUM_FLOAT);
		
		String text = token.getText();
		
		if (text.startsWith("<NaN>")) {
		self = new Float(Float.NaN);
		}
		else if (text.startsWith("<Inf>")) {
		self = new Float(Float.POSITIVE_INFINITY);
		}
		else if (text.startsWith("-<Inf>")) {
		self = new Float(Float.NEGATIVE_INFINITY);
		}
		else {
		try {
		self = new Float(text);
		}
		catch (NumberFormatException e) {
		throw new antlr.RecognitionException(e.toString());
		}
		}
		
		return self;
	}
	
	public final Integer  aIntegerLiteral(
		
	) throws RecognitionException, TokenStreamException {
		Integer self;
		
		Token  token = null;
		
		token = LT(1);
		match(INT_LITERAL);
		
		try {
		self = new Integer(NumberParser.decodeInt(token.getText()));
		}
		catch (NumberFormatException e) {
		throw new antlr.RecognitionException(e.toString());
		}
		
		return self;
	}
	
	public final Long  aLongLiteral(
		
	) throws RecognitionException, TokenStreamException {
		Long self;
		
		Token  token = null;
		
		token = LT(1);
		match(LONG_LITERAL);
		
		try {
		self = new Long(NumberParser.decodeLong
		(token.getText().substring(0, token.getText().length() - 1)));
		}
		catch (NumberFormatException e) {
		throw new antlr.RecognitionException(e.toString());
		}
		
		return self;
	}
	
	public final int  aFieldRefOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 127:
		{
			match(127);
			self = Constants.opc_getfield;
			break;
		}
		case 128:
		{
			match(128);
			self = Constants.opc_getstatic;
			break;
		}
		case 129:
		{
			match(129);
			self = Constants.opc_putfield;
			break;
		}
		case 130:
		{
			match(130);
			self = Constants.opc_putstatic;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final int  aMethodRefOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 131:
		{
			match(131);
			self = Constants.opc_invokestatic;
			break;
		}
		case 132:
		{
			match(132);
			self = Constants.opc_invokespecial;
			break;
		}
		case 133:
		{
			match(133);
			self = Constants.opc_invokevirtual;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final int  aClassRefOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 134:
		{
			match(134);
			self = Constants.opc_checkcast;
			break;
		}
		case 135:
		{
			match(135);
			self = Constants.opc_instanceof;
			break;
		}
		case 136:
		{
			match(136);
			self = Constants.opc_new;
			break;
		}
		case 137:
		{
			match(137);
			self = Constants.opc_anewarray;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final int  aJumpOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 138:
		{
			match(138);
			self = Constants.opc_goto;
			break;
		}
		case 139:
		{
			match(139);
			self = Constants.opc_if_acmpeq;
			break;
		}
		case 140:
		{
			match(140);
			self = Constants.opc_if_acmpne;
			break;
		}
		case 141:
		{
			match(141);
			self = Constants.opc_if_icmpeq;
			break;
		}
		case 142:
		{
			match(142);
			self = Constants.opc_if_icmpne;
			break;
		}
		case 143:
		{
			match(143);
			self = Constants.opc_if_icmplt;
			break;
		}
		case 144:
		{
			match(144);
			self = Constants.opc_if_icmpge;
			break;
		}
		case 145:
		{
			match(145);
			self = Constants.opc_if_icmpgt;
			break;
		}
		case 146:
		{
			match(146);
			self = Constants.opc_if_icmple;
			break;
		}
		case 147:
		{
			match(147);
			self = Constants.opc_ifeq;
			break;
		}
		case 148:
		{
			match(148);
			self = Constants.opc_ifne;
			break;
		}
		case 149:
		{
			match(149);
			self = Constants.opc_iflt;
			break;
		}
		case 150:
		{
			match(150);
			self = Constants.opc_ifge;
			break;
		}
		case 151:
		{
			match(151);
			self = Constants.opc_ifgt;
			break;
		}
		case 152:
		{
			match(152);
			self = Constants.opc_ifle;
			break;
		}
		case 153:
		{
			match(153);
			self = Constants.opc_ifnonnull;
			break;
		}
		case 154:
		{
			match(154);
			self = Constants.opc_ifnull;
			break;
		}
		case 155:
		{
			match(155);
			self = Constants.opc_jsr;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	public final int  aLocalVarOpcode(
		
	) throws RecognitionException, TokenStreamException {
		int self;
		
		
		switch ( LA(1)) {
		case 156:
		{
			match(156);
			self = Constants.opc_iload;
			break;
		}
		case 157:
		{
			match(157);
			self = Constants.opc_fload;
			break;
		}
		case 158:
		{
			match(158);
			self = Constants.opc_aload;
			break;
		}
		case 159:
		{
			match(159);
			self = Constants.opc_lload;
			break;
		}
		case 160:
		{
			match(160);
			self = Constants.opc_dload;
			break;
		}
		case 161:
		{
			match(161);
			self = Constants.opc_istore;
			break;
		}
		case 162:
		{
			match(162);
			self = Constants.opc_fstore;
			break;
		}
		case 163:
		{
			match(163);
			self = Constants.opc_astore;
			break;
		}
		case 164:
		{
			match(164);
			self = Constants.opc_lstore;
			break;
		}
		case 165:
		{
			match(165);
			self = Constants.opc_dstore;
			break;
		}
		case 166:
		{
			match(166);
			self = Constants.opc_ret;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"LBRACE",
		"RBRACE",
		"\"@source\"",
		"\"class\"",
		"\"interface\"",
		"\"public\"",
		"\"protected\"",
		"\"private\"",
		"\"static\"",
		"\"abstract\"",
		"\"final\"",
		"\"native\"",
		"\"strictfp\"",
		"\"synchronized\"",
		"\"transient\"",
		"\"volatile\"",
		"\"extends\"",
		"\"implements\"",
		"COMMA",
		"SEMI",
		"EQUAL",
		"\"throws\"",
		"\"@var\"",
		"COLON",
		"LBRACK",
		"RBRACK",
		"\"@line\"",
		"\"@catch\"",
		"\"@wide\"",
		"\"@aaload\"",
		"\"@aastore\"",
		"\"@aconst_null\"",
		"\"@areturn\"",
		"\"@arraylength\"",
		"\"@athrow\"",
		"\"@baload\"",
		"\"@bastore\"",
		"\"@caload\"",
		"\"@castore\"",
		"\"@d2f\"",
		"\"@d2i\"",
		"\"@d2l\"",
		"\"@dadd\"",
		"\"@daload\"",
		"\"@dastore\"",
		"\"@dcmpg\"",
		"\"@dcmpl\"",
		"\"@ddiv\"",
		"\"@dmul\"",
		"\"@dneg\"",
		"\"@drem\"",
		"\"@dreturn\"",
		"\"@dsub\"",
		"\"@dup\"",
		"\"@dup_x1\"",
		"\"@dup_x2\"",
		"\"@dup2\"",
		"\"@dup2_x1\"",
		"\"@dup2_x2\"",
		"\"@f2d\"",
		"\"@f2i\"",
		"\"@f2l\"",
		"\"@fadd\"",
		"\"@faload\"",
		"\"@fastore\"",
		"\"@fcmpg\"",
		"\"@fcmpl\"",
		"\"@fdiv\"",
		"\"@fmul\"",
		"\"@fneg\"",
		"\"@frem\"",
		"\"@freturn\"",
		"\"@fsub\"",
		"\"@i2b\"",
		"\"@i2c\"",
		"\"@i2d\"",
		"\"@i2f\"",
		"\"@i2l\"",
		"\"@i2s\"",
		"\"@iadd\"",
		"\"@iaload\"",
		"\"@iand\"",
		"\"@iastore\"",
		"\"@idiv\"",
		"\"@imul\"",
		"\"@ineg\"",
		"\"@ior\"",
		"\"@irem\"",
		"\"@ireturn\"",
		"\"@ishl\"",
		"\"@ishr\"",
		"\"@isub\"",
		"\"@iushr\"",
		"\"@ixor\"",
		"\"@l2d\"",
		"\"@l2f\"",
		"\"@l2i\"",
		"\"@ladd\"",
		"\"@laload\"",
		"\"@land\"",
		"\"@lastore\"",
		"\"@lcmp\"",
		"\"@ldiv\"",
		"\"@lmul\"",
		"\"@lneg\"",
		"\"@lor\"",
		"\"@lrem\"",
		"\"@lreturn\"",
		"\"@lshl\"",
		"\"@lshr\"",
		"\"@lsub\"",
		"\"@lushr\"",
		"\"@lxor\"",
		"\"@monitorenter\"",
		"\"@monitorexit\"",
		"\"@nop\"",
		"\"@pop\"",
		"\"@pop2\"",
		"\"@return\"",
		"\"@saload\"",
		"\"@sastore\"",
		"\"@swap\"",
		"\"@const\"",
		"\"@getfield\"",
		"\"@getstatic\"",
		"\"@putfield\"",
		"\"@putstatic\"",
		"\"@invokestatic\"",
		"\"@invokespecial\"",
		"\"@invokevirtual\"",
		"\"@checkcast\"",
		"\"@instanceof\"",
		"\"@new\"",
		"\"@anewarray\"",
		"\"@goto\"",
		"\"@if_acmpeq\"",
		"\"@if_acmpne\"",
		"\"@if_icmpeq\"",
		"\"@if_icmpne\"",
		"\"@if_icmplt\"",
		"\"@if_icmpge\"",
		"\"@if_icmpgt\"",
		"\"@if_icmple\"",
		"\"@ifeq\"",
		"\"@ifne\"",
		"\"@iflt\"",
		"\"@ifge\"",
		"\"@ifgt\"",
		"\"@ifle\"",
		"\"@ifnonnull\"",
		"\"@ifnull\"",
		"\"@jsr\"",
		"\"@iload\"",
		"\"@fload\"",
		"\"@aload\"",
		"\"@lload\"",
		"\"@dload\"",
		"\"@istore\"",
		"\"@fstore\"",
		"\"@astore\"",
		"\"@lstore\"",
		"\"@dstore\"",
		"\"@ret\"",
		"\"@newarray\"",
		"\"@multianewarray\"",
		"\"@invokeinterface\"",
		"\"@iinc\"",
		"\"@switch\"",
		"\"@default\"",
		"LPAREN",
		"RPAREN",
		"DOT",
		"IDENT",
		"QUOTED_IDENT",
		"INIT",
		"CLINIT",
		"NUM_DOUBLE",
		"NUM_FLOAT",
		"INT_LITERAL",
		"LONG_LITERAL",
		"STRING_LITERAL"
	};
	
	private static final long _tokenSet_0_data_[] = { 1048064L, 0L, 4222124650659840L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	
	}
